import React from 'react';
import { Icon, Button, Select, Spin, Table, message } from 'antd';
import { companySearch } from '../../../tools.js';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import './technology.less';

import WebsiteAdd from './websiteAdd.jsx';
import WebsiteChange from './websiteChange.jsx';

const Cognizance = React.createClass({
    loadData(pageNo) {
        this.state.data = [];
        this.setState({
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/techproject/listTechWebsite",
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.pagination.pageSize,
                unitName: this.state.unitName,
            },
            success: function (data) {
                if (!data.data || !data.data.list) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                    return;
                };
                for (let i = 0; i < data.data.list.length; i++) {
                    let thisdata = data.data.list[i];
                    this.state.data.push({
                        key: i,
                        id: thisdata.id,
                        uid: thisdata.uid,
                        unitName: thisdata.unitName,
                        department: thisdata.department,
                        webSite: thisdata.website,
                        userName: thisdata.accountNumber,
                        password: thisdata.password
                    });
                };
                this.state.pagination.current = data.data.pageNo;
                this.state.pagination.total = data.data.totalCount;
                this.setState({
                    dataSource: this.state.data,
                    pagination: this.state.pagination
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getCompanyList() {
        this.setState({
            loading: true
        });
        $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/techproject/websiteUnit",
            success: function (data) {
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                    return;
                };
                let _me = this;
                for (var item in data.data) {
                    _me.state.companyOption.push(
                        <Select.Option value={data.data[item]} key={data.data[item]}>{data.data[item]}</Select.Option>
                    )
                    _me.state.companyAddOption.push(
                        <Select.Option value={item} key={item}>{data.data[item]}</Select.Option>
                    )
                };
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
            companyOption: [],
            companyAddOption: [],
            authorOption: [],
            selectedRows: [],
            selectedRowKeys: [],
            loading: false,
            showAdd: false,
            showDesc: false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [
                {
                    title: '公司',
                    dataIndex: 'unitName',
                    key: 'unitName'
                }, {
                    title: '科技单位',
                    dataIndex: 'department',
                    key: 'department'
                }, {
                    title: '网址',
                    dataIndex: 'webSite',
                    key: 'webSite'
                }, {
                    title: '用户名',
                    dataIndex: 'userName',
                    key: 'userName'
                }, {
                    title: '密码',
                    dataIndex: 'password',
                    key: 'password'
                }
            ],
            dataSource: []
        };
    },
    componentWillMount() {
        this.loadData();
        this.getCompanyList();
    },
    tableRowClick(record, index) {
        this.state.RowData = record;
        this.setState({
            showDesc: true
        });
    },
    addClick() {
        this.setState({
            showAdd: true
        });
    },
    delectRow() {
        let deletedIds = [];
        for (let idx = 0; idx < this.state.selectedRows.length; idx++) {
            let rowItem = this.state.selectedRows[idx];
            if (rowItem.id) {
                deletedIds.push(rowItem.id)
            }
        };
        this.setState({
            selectedRowKeys: [],
            loading: deletedIds.length > 0
        });
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/techproject/deleteTechWebsite",
            data: {
                ids: deletedIds
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('删除成功！');
                this.setState({
                    loading: false,
                });
            } else {
                message.warning(data.error[0].message);
            };
            this.loadData();
        }.bind(this));
    },
    closeDesc(e) {
        this.state.showDesc = e;
        this.loadData();
    },
    closeAdd(e) {
        this.state.showAdd = e;
        this.loadData();
    },
    search() {
        this.loadData();
    },
    reset() {
        this.state.unitName = undefined;
        this.loadData();
    },
    render() {
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
                this.setState({
                    selectedRows: selectedRows,
                    selectedRowKeys: selectedRowKeys
                });
            }
        };
        const hasSelected = this.state.selectedRowKeys.length > 0;
        return (
            <div className="foster-content" >
                <div className="content-title">
                    <span>科技单位网址管理</span>
                    <div className="foster-query" style={{ float: "right" }}>
                        <div>
                            <Button style={{ background: "#ea0862", border: "none", color: "#fff" }}
                                onClick={this.addClick}>创建新单位网址<Icon type="plus" /></Button>
                        </div>
                    </div>
                </div>

                <div className="foster-query">
                    <Select placeholder="选择公司"
                        style={{ width: 200 }}
                        value={this.state.unitName}
                        showSearch
                        filterOption={companySearch}
                        onChange={(e) => { this.setState({ unitName: e }) }}>
                        {this.state.companyOption}
                    </Select>
                    <Button type="primary" onClick={this.search}>搜索</Button>
                    <Button onClick={this.reset}>重置</Button>
                    <Button style={{ background: "#3fcf9e", border: "none", color: "#fff" }}
                        disabled={!hasSelected}
                        onClick={this.delectRow}>删除<Icon type="minus" /></Button>
                </div>

                <div className="patent-table">
                    <Spin spinning={this.state.loading}>
                        <Table columns={this.state.columns}
                            rowSelection={rowSelection}
                            dataSource={this.state.dataSource}
                            pagination={this.state.pagination}
                            onRowClick={this.tableRowClick} />
                    </Spin>
                </div>
                <WebsiteChange
                    data={this.state.RowData}
                    companyAddOption={this.state.companyAddOption}
                    showDesc={this.state.showDesc}
                    closeDesc={this.closeDesc} />
                <WebsiteAdd
                    companyAddOption={this.state.companyAddOption}
                    showAdd={this.state.showAdd}
                    closeAdd={this.closeAdd} />
            </div >
        );
    }
});

export default Cognizance;